#include <windows.h>
#include <winuser.h>
#include <winsock.h>

#define MAX 4096

SOCKET establish(unsigned short portnum)
{
  char   myname[256];
  SOCKET s;
  struct sockaddr_in sa;
  struct hostent *hp;

  memset(&sa, 0, sizeof(struct sockaddr_in)); /* clear our address */
  gethostname(myname, sizeof(myname));        /* who are we? */
  hp = gethostbyname(myname);                 /* get our address info */
  if (hp == NULL)                             /* we don't exist !? */
    return(INVALID_SOCKET);
  sa.sin_family = hp->h_addrtype;             /* this is our host address */
  sa.sin_port = htons(portnum);               /* this is our port number */
  s = socket(AF_INET, SOCK_STREAM, 0);        /* create the socket */
  if (s == INVALID_SOCKET)
    return INVALID_SOCKET;

  /* bind the socket to the internet address */
  if (bind(s, (struct sockaddr *)&sa, sizeof(struct sockaddr_in)) == SOCKET_ERROR)
  {
    closesocket(s);
    return(INVALID_SOCKET);
  }
  listen(s, 3);                               /* max # of queued connects */
    return(s);
}

SOCKET call_socket(const char *hostname, unsigned short portnum)
{
  struct sockaddr_in sa;
  struct hostent *hp;
  SOCKET s;
  unsigned long addr;

  memset(&sa, 0, sizeof(sa));
  addr = inet_addr(hostname);
  if (addr != INADDR_NONE)
  {
    sa.sin_addr.s_addr = addr;
    sa.sin_family = AF_INET;
  }
  else
  {
    hp = gethostbyname(hostname);
    if (hp == NULL) /* we don't know who this host is */
      return INVALID_SOCKET;
    memcpy((char *)&sa.sin_addr, hp->h_addr, hp->h_length); /* set address */
    sa.sin_family = hp->h_addrtype;
  }
  sa.sin_port = htons((u_short)portnum);
  s = socket(sa.sin_family, SOCK_STREAM, 0);
  if (s == INVALID_SOCKET)
    return INVALID_SOCKET;
  
  /* try to connect to the specified socket */
  if (connect(s, (struct sockaddr *)&sa, sizeof(sa)) == SOCKET_ERROR)
  {
    closesocket(s);
    return INVALID_SOCKET;
  }
  return s;
}

short read_data(SOCKET s, char *buf, short len)
{
  short bytes,
        num;

  bytes = 0;
  num = 0;
  while (bytes < len)
  {
    num = recv(s, buf, len - bytes, 0);
    if (num > 0)
    {
      bytes += num;
      buf += num;
    }
    else 
    {
      if (num < 0)
        return -1;
    }
  }
  
  return bytes;
}

short send_data(SOCKET s, char *buf, short len)
{
  short bytes,
        num;

  bytes = 0;
  num = 0;
  while (bytes < len)
  {
    num = send(s, buf, len - bytes, 0);
    if (num > 0)
    {
      bytes += num;
      buf += num;
    }
    else 
    {
      if (num < 0)
        return -1;
    }
  }
  
  return bytes;
}

void main()
{
  WSADATA wsadata;
  SOCKET sock;
  SOCKADDR_IN local_sin;
  char buf[MAX];
  
  if (WSAStartup(MAKEWORD(1, 1), &wsadata) != 0)
  {
    printf("Error initializing Winsock!\n");
    return;
  }

  sock = call_socket("mail.smsd.org", 110);
  if (sock == INVALID_SOCKET)
  {
    printf("Socket open failed!\n");
    WSACleanup();
    return;
  }

  buf[recv(sock, buf, MAX, 0)] = '\0';
  printf("%s", buf);
  strcpy(buf, "user icphilli\n");
  send(sock, buf, strlen(buf), 0);

  closesocket(sock);
  WSACleanup();
}
